Move displaying installation notes into umount_chroot()
[grml-debootstrap.git] / grml-debootstrap
index 984aa1a..946b5be 100755 (executable)
@@ -11,7 +11,7 @@ set -e # exit on any error
 
 # variables {{{
 PN="$(basename $0)"
-VERSION='0.23'
+VERSION='0.30'
 MNTPOINT="/mnt/debootstrap.$$"
 
 # inside the chroot system locales might not be available, so use minimum:
@@ -36,44 +36,46 @@ Usage: $PN [options]
 
 Bootstrap options:
 
-  -m, --mirror=URL       Mirror which should be used for apt-get/aptitude.
-  -i, --iso=mnt          Mountpoint where a Debian ISO is mounted to, for use
+  -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
+  -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
                            instead of fetching packages from a mirror.
-  -r, --release=name     Release of new Debian system (default: stable).
-  -t, --target=target    Target partition (/dev/...) or directory.
-  -p, --mntpoint=mnt     Mountpoint used for mounting the target system.
-      --debopt=params    Extra parameters passed to the debootstrap.
+  -r, --release <name>   Release of new Debian system (default: lenny).
+  -t, --target <target>  Target partition (/dev/...) or directory where the
+                         system should be installed to.
+  -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
+                         has no effect if -t is given and represents a directory.
+      --debopt <params>  Extra parameters passed to the debootstrap command.
       --interactive      Use interactive mode (frontend).
       --nodebootstrap    Skip debootstrap, only do configuration to the target.
+      --groot <device>   Root device for usage in grub, corresponds with
+                           \$TARGET in grub syntax, like hd0,0 for /dev/sda1.
+      --grub <device>    Target for grub installation. Use grub syntax for
+                           specifying, like hd0 for /dev/sda.
+      --arch <arch>      Architecture to use. Currently only i386 is supported.
 
 Configuration options:
 
-
-  -c, --config=file      Use specified configuration file, defaults to
-                           /etc/debootstrap/config
-  -d, --confdir=path     Place of config files for debootstrap, defaults to
-                           /etc/debootstrap
-      --packages[=f]     Install packages defined in <confdir>/packages. Option
-                           arg: alternative package list file.
-      --debconf[=f]      Pre-seed packages using <confdir>/debconf-selections.
-                           Option arg: alternative pre-seed db file.
-      --keep_src_list    Do not overwrite user provided apt sources.list.
-      --hostname=name    Hostname of Debian system.
-      --password=pwd     Use specified password as password for user root.
-
-      --bootappend=line  Add specified appendline to kernel whilst booting.
-      --groot=device     Root device for usage in grub, corresponds with
-                           $TARGET in grub syntax, like hd0,0 for /dev/sda1.
-      --grub=device      Target for grub installation. Use grub syntax for
-                           specifying, like hd0 for /dev/sda.
+  -c, --config <file>      Use specified configuration file, defaults to
+                             /etc/debootstrap/config
+  -d, --confdir <path>     Place of config files for debootstrap, defaults
+                             to /etc/debootstrap
+      --packages <file>    Install packages defined in specified list file.
+      --debconf <file>     Pre-seed packages using specified pre-seed db file.
+      --keep_src_list      Do not overwrite user provided apt sources.list.
+      --hostname <name>    Hostname of Debian system.
+      --password <pwd>     Use specified password as password for user root.
+      --bootappend <line>  Add specified appendline to kernel whilst booting.
+      --chroot-scripts <d> Execute chroot scripts from specified directory.
+      --scripts <dir>      Execute scripts from specified directory.
 
 Other options:
 
-  -v, --verbose          Increase verbosity.
-  -h, --help             Print this usage information and exit.
-  -V, --version          Show summary of options and exit.
+  -v, --verbose            Increase verbosity.
+  -h, --help               Print this usage information and exit.
+  -V, --version            Show summary of options and exit.
 
-Send bugreports to the grml-team: bugs@grml.org || http://grml.org/bugs/
+Usage examples can be found in the grml-debootstrap manpage.
+Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
 "
 }
 
@@ -104,7 +106,14 @@ fi
 
 # cmdline handling {{{
 # source external command line parameter-processing script
-. /usr/share/grml-debootstrap/functions/cmdlineopts.clp
+if [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
+   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
+elif [ -r ./cmdlineopts.clp ] ; then
+   . ./cmdlineopts.clp
+else
+   echo "Error: cmdline function file not found, exiting.">&2
+   exit 1
+fi
 
 # == business-logic of command line parameter-processing
 
@@ -123,23 +132,26 @@ fi
 }
 # }}}
 
-[ "$_opt_mirror" ]             && MIRROR=$_opt_mirror
-[ "$_opt_iso" ]                        && ISO=$_opt_iso
-[ "$_opt_release" ]            && RELEASE=$_opt_release
-[ "$_opt_target" ]             && TARGET=$_opt_target
-[ "$_opt_mntpoint" ]           && MNTPOINT=$_opt_mntpoint
-[ "$_opt_debopt" ]             && DEBOOTSTRAP_OPT=$_opt_debopt
-[ "$_opt_interactive" ]                && INTERACTIVE=1
-[ "$_opt_config" ]             && CONFIGFILE=$_opt_config
-[ "$_opt_packages_set" ]       && PACKAGES='yes'
-[ "$_opt_debconf_set" ]                && DEBCONF='yes'
-[ "$_opt_keep_src_list" ]      && KEEP_SRC_LIST='yes'
-[ "$_opt_hostname" ]           && HOSTNAME=$_opt_hostname
-[ "$_opt_password" ]           && ROOTPASSWORD=$_opt_password
-[ "$_opt_bootappend" ]         && BOOT_APPEND=$_opt_bootappend
-[ "$_opt_groot" ]              && GROOT=$_opt_groot
-[ "$_opt_grub" ]               && GRUB=$_opt_grub
-[ "$_opt_verbose" ]            && VERBOSE="-v"
+[ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
+[ "$_opt_iso" ]                 && ISO=$_opt_iso
+[ "$_opt_release" ]             && RELEASE=$_opt_release
+[ "$_opt_target" ]              && TARGET=$_opt_target
+[ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
+[ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
+[ "$_opt_interactive" ]         && INTERACTIVE=1
+[ "$_opt_config" ]              && CONFIGFILE=$_opt_config
+[ "$_opt_packages_set" ]        && PACKAGES='yes'
+[ "$_opt_debconf_set" ]         && DEBCONF='yes'
+[ "$_opt_scripts_set" ]         && SCRIPTS='yes'
+[ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
+[ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
+[ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
+[ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
+[ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
+[ "$_opt_groot" ]               && GROOT=$_opt_groot
+[ "$_opt_grub" ]                && GRUB=$_opt_grub
+[ "$_opt_arch" ]                && ARCH=$_opt_arch
+[ "$_opt_verbose" ]             && VERBOSE="-v"
 
 [ "$_opt_help" ] && {
   usage ; eend 0
@@ -169,7 +181,7 @@ prompt_for_target()
   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
                sed 's/*//' | \
                grep -v 'Extended$' | \
-               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
+               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md* 2>/dev/null || true);
 
   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
      dialog --title "$PN" --trim \
@@ -193,22 +205,39 @@ prompt_for_target()
 prompt_for_bootmanager()
 {
   ADDITIONAL_PARAMS=""
-  for device in sda hda; do
-    if [ /dev/$device != ${TARGET%[0-9]} ]; then
+
+  if echo "$TARGET" | grep -q "/dev/md" ; then
+     MBRPART="all disks of Software RAID $TARGET"
+  else
+     # figure out whole disk device
+     found=
+     for device in /dev/disk/by-id/*
+     do
+        [ $(readlink -f $device) = ${TARGET} ] || continue
+        found=1
+        break
+     done
+     [ -n "$found" ] && MBRDISK=$(echo ${device}|sed -e 's/-part[0-9][0-9]*$//')
+     if [ -e "$MBRDISK" ]; then
+        MBRDISK=$(readlink -f $MBRDISK)
+     else
+        # fall back to old behaviour
+        MBRDISK=$(echo ${TARGET} | sed -e 's/[0-9][0-9]*$/')
+     fi
+
+     MBRPART="MBR of $MBRDISK"
+  fi
+
+  for device in cciss/c0d0 sda hda; do
+    if [ /dev/$device != ${MBRDISK} ]; then
       grep -q $device /proc/partitions && \
-      ADDITIONAL_PARAMS=:$device:"install bootmanager grub into MBR of /dev/${device}"
+      ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
     fi
   done
   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
 
   OIFS="$IFS"; IFS=:
 
-  if echo $TARGET | grep -q "/dev/md" ; then
-     MBRPART="all disks of Software RAID $TARGET"
-  else
-     MBRPART="MBR of ${TARGET%[0-9]}"
-  fi
-
   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
             mbr       "install bootmanager into $MBRPART" \
@@ -221,10 +250,10 @@ prompt_for_bootmanager()
   case "$GETMBR" in
     mbr)
       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
-      if echo $TARGET | grep -q "*md*" ; then
-         BOOT_PARTITION="${TARGET}"
+      if echo "$TARGET" | grep -q "/dev/md" ; then
+         BOOT_PARTITION="$TARGET"
       else
-         BOOT_PARTITION="${TARGET%[0-9]}"
+         BOOT_PARTITION="$MBRDISK"
       fi
       ;;
     partition)
@@ -246,12 +275,14 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  RELEASE="$(dialog --stdout --title "${PN}" --default-item etch --menu \
+  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='lenny'
+  RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
             "Please enter the Debian release you would like to use for installation:" \
-            0 50 3 \
-            etch   Debian/stable \
-            lenny  Debian/testing \
-            sid    Debian/unstable)"
+            0 50 4 \
+            etch     Debian/old-stable \
+            lenny    Debian/stable \
+            squeeze  Debian/testing \
+            sid      Debian/unstable)"
 }
 # }}}
 
@@ -260,7 +291,7 @@ prompt_for_hostname()
 {
   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
             "Please enter the hostname you would like to use for installation:" \
-            0 0 grml)"
+            0 0 $HOSTNAME)"
 }
 # }}}
 
@@ -288,9 +319,25 @@ prompt_for_password()
 # ask for Debian mirror {{{
 prompt_for_mirror()
 {
-  MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
-            "Please enter Debian mirror you would like to use for installing packages." \
-            0 0 http://ftp.de.debian.org/debian)"
+  [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
+
+  CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
+          --menu "Where do you want to install from?" 0 0 0 \
+            net   "install via network (downloading from mirror)" \
+            local "install from local directory/mirror"
+          )
+
+  if [ "$CHOOSE_MIRROR" = 'net' ] ; then
+     [ -n "$MIRROR" ] || MIRROR='http://cdn.debian.net/debian'
+     MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
+               "Please enter Debian mirror you would like to use for installing packages." \
+               0 0 $MIRROR)"
+  else # CHROOT_VARIABLES == local
+     [ -n "$ISO" ] || ISO='/mnt/mirror'
+     ISO="$(dialog --stdout --title "${PN}" --inputbox \
+               "Please enter directory name you would like to use for installing packages." \
+               0 0 $ISO)"
+  fi
 }
 # }}}
 
@@ -303,33 +350,48 @@ grubdevice() {
   fi
 
   device="$1"
-  device_map=/boot/grub/device.map
+  device_map=$(mktemp)
 
   # create device.map
-  if ! [ -f "$device_map" ] ; then
-     echo 'quit' | grub --device-map="$device_map" 1>/dev/null 2>&1
+  if which grub >/dev/null 2>&1 ; then
+     echo 'quit' | grub --device-map="$device_map" >/dev/null 2>&1
+  elif which grub-mkdevicemap >/dev/null 2>&1 ; then
+     grub-mkdevicemap --no-floppy --device-map="$device_map" >/dev/null 2>&1
+  else
+    echo "Error: neither grub nor grub-mkdevicemap command found." >&2
+    return 1
   fi
 
   # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
-  tmp_disk=`echo "$device" | sed -e 's%\([sh]d[a-z]\)[0-9]*$%\1%' \
+  tmp_disk=$(echo "$device" | sed -e 's%\(\(s\|h\|v\|xv\)d[a-z]\)[0-9]*$%\1%' \
                     -e 's%\(fd[0-9]*\)$%\1%' \
                     -e 's%/part[0-9]*$%/disc%' \
-                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%'`
-  tmp_part=`echo "$device" | sed -e 's%.*/[sh]d[a-z]\([0-9]*\)$%\1%' \
+                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%' \
+                    -e 's%\(mmcblk[0-9]d[0-9]*\).*$%\1%' \
+                    -e 's%\(/mapper/mpath[0-9]\+\)-part[0-9]\+$%\1%')
+  tmp_part=$(echo "$device" | sed -e 's%.*/\(s\|h\|v\|xv\)d[a-z]\([0-9]*\)$%\2%' \
                     -e 's%.*/fd[0-9]*$%%' \
                     -e 's%.*/floppy/[0-9]*$%%' \
                     -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
-                    -e 's%.*c[0-7]d[0-9]*p*%%'`
+                    -e 's%.*c[0-7]d[0-9]*p*%%' \
+                    -e 's%.*mmcblk[0-9]d[0-9]*p%%' \
+                    -e 's%.*/mapper/mpath[0-9]\+-part\([0-9]\+\)%\1%')
   tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
 
+  if [ -z "$tmp_drive" ]; then
+    echo "Error: $device does not have any corresponding BIOS drive." >&2
+    return 1
+  fi
+
   case $1 in
      /dev/[sh]d[a-z]) # we expect something like 'hd0'
         echo "$tmp_drive"
         ;;
       *) # we expect something like 'hd0,0'
-        echo "$tmp_drive" | sed "s%$%,`expr $tmp_part - 1`%" # FIXME => md0
+        echo "$tmp_drive" | sed "s%$%,$(expr $tmp_part - 1)%" # FIXME => md0
         ;;
   esac
+  rm -f "$device_map"
 }
 # }}}
 
@@ -415,6 +477,19 @@ fi
 }
 # }}}
 
+# user should recheck his configuration {{{
+# support full automatic installation:
+checkforrun() {
+   dialog --timeout 10 --title "$PN" \
+          --yesno "Do you want to stop at this stage?
+
+Notice: you are running ${PN} in non-interactive mode.
+${PN} will install Debian ${RELEASE} on ${TARGET}.
+Last chance to quit. Timeout of 10 seconds running....
+
+Do you want to stop now?" 0 0 2>/dev/null
+}
+
 # make sure the user is aware of the used configuration {{{
 checkconfiguration()
 {
@@ -437,6 +512,8 @@ elif [ -n "$INTERACTIVE" ] ; then
    Using hostname   $HOSTNAME"
    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
    Using mirror:    $MIRROR"
+   [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
+   Using ISO:       $ISO"
 
    INFOTEXT="$INFOTEXT
 
@@ -449,13 +526,19 @@ else # if not running automatic installation display configuration and prompt fo
    einfo "$PN - Please recheck configuration before execution:"
    echo
    echo "   Target:          $TARGET"
-      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
-      [ -n "$GRUB" ]    && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
-      [ -n "$RELEASE" ] && echo "   Using release:   $RELEASE"
-      [ -n "$MIRROR" ]  && echo "   Using mirror:    $MIRROR"
-      [ -n "$ISO" ]     && echo "   Using iso:       $ISO"
-      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
-      echo
+
+   # do not display if MNTPOINT is the default one
+   case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
+
+   [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
+   [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
+   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
+   [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
+   [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
+
+   echo "   Important! Continuing will delete all data from ${TARGET}!"
+
+   echo
    einfon "Is this ok for you? [y/N] "
    read a
    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
@@ -473,8 +556,7 @@ interactive_mode()
 
   prompt_for_swraid
 
-  # do not prompt for partition dialog if swraid has been configured already
-  [ -n "$TARGET" ] || prompt_for_target
+  prompt_for_target
 
   prompt_for_bootmanager
 
@@ -492,7 +574,6 @@ interactive_mode()
         TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
         GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
         GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
-        echo "debug: GRUB = $GRUB - GROOT = $GROOT" >/tmp/debug # FIXME
      fi
   else
      [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
@@ -500,8 +581,6 @@ interactive_mode()
   fi
 
   prompt_for_mirror
-
-  checkconfiguration
 }
 
 # run interactive mode if we didn't get the according configuration yet
@@ -512,6 +591,8 @@ if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
 fi
 # }}}
 
+checkconfiguration
+
 # finally make sure at least $TARGET is set [the partition for the new system] {{{
 if [ -n "$TARGET" ] ; then
    SHORT_TARGET="${TARGET##*/}"
@@ -597,7 +678,12 @@ bailout(){
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
         [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
-        einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+
+        if [ -n "$DIRECTORY" ] ; then
+          einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
+        else
+          einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+        fi
 
         if [ -n "$STAGES" ] ; then
            echo -n "Removing stages directory ${STAGES}: "
@@ -633,26 +719,23 @@ stage() {
 }
 # }}}
 
-# user should recheck his configuration {{{
-# support full automatic installation:
-checkforrun() {
-   dialog --timeout 10 --title "$PN" \
-          --yesno "Do you want to stop at this stage?
-
-Notice: you are running ${PN} in non-interactive mode.
-${PN} will install Debian ${RELEASE} on ${TARGET}.
-Last chance to quit. Timeout of 10 seconds running....
-
-Do you want to stop now?" 0 0 2>/dev/null
-}
-
 # create filesystem {{{
 mkfs() {
-  if [ -n "$MKFS" ] ; then
-     einfo "Running $MKFS on $TARGET"
-     $MKFS $TARGET
-     TARGET_UUID="$(vol_id -u $TARGET 2>/dev/null || echo '')"
-     eend $?
+  if [ -n "$DIRECTORY" ] ; then
+     einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
+  else
+    if grep -q "$TARGET" /proc/mounts ; then
+      eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
+      exit 1
+    fi
+
+    if [ -n "$MKFS" ] ; then
+       einfo "Running $MKFS on $TARGET"
+       $MKFS $TARGET
+       TARGET_UUID="$(vol_id -u $TARGET 2>/dev/null || echo '')"
+       eend $?
+    fi
+
   fi
 }
 # }}}
@@ -673,7 +756,7 @@ mount_target() {
      einfo "Running grml-debootstrap on a directory, nothing to mount."
   else
      if grep -q $TARGET /proc/mounts ; then
-        eerror "$TARGET already mounted, exiting."
+        ewarn "$TARGET already mounted, continuing anyway." ; eend 0
      else
        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
        einfo "Mounting $TARGET to $MNTPOINT"
@@ -692,17 +775,18 @@ mount_target() {
 
 # install main chroot {{{
 debootstrap_system() {
-  if ! grep -q $MNTPOINT /proc/mounts ; then
-     mount_target
-  fi
   if [ "$_opt_nodebootstrap" ]; then
      einfo "Skipping debootstrap as requested."
      return
   fi
-  if grep -q $MNTPOINT /proc/mounts || [ -n "$DIRECTORY" ] ; then
+
+  if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
      einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR || \
-     $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+     if [ -n "$MIRROR" ] ; then
+        $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
+     else
+        $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+     fi
      eend $?
   else
      eerror "Error: $MNTPOINT not mounted, can not continue."
@@ -720,23 +804,23 @@ preparechroot() {
   touch $CHROOT_VARIABLES
   chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
   echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
-  [ -n "$ARCH" ]         && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
-  [ -n "$GROOT" ]        && echo "GROOT=$GROOT"               >> $CHROOT_VARIABLES
-  [ -n "$GRUB" ]         && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
-  [ -n "$HOSTNAME" ]     && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
-  [ -n "$ISODIR" ]       && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
-  [ -n "$ISO" ]          && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
-  [ -n "$MIRROR" ]       && echo "CHROOTMIRROR=$MIRROR"       >> $CHROOT_VARIABLES
-  [ -n "$MIRROR" ]       && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
+  [ -n "$ARCH" ]          && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
+  [ -n "$GROOT" ]         && echo "GROOT=$GROOT"               >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]          && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]      && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
+  [ -n "$INSTALL_NOTES" ] && echo "INSTALL_NOTES=$INSTALL_NOTES" >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]        && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]           && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]        && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
   [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
-  [ -n "$PACKAGES" ]     && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
-  [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
-  [ -n "$TARGET" ]       && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
-  [ -n "$TARGET_UUID" ]  && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]      && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ]  && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]        && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]   && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
 
   cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
-  mkdir $MNTPOINT/etc/debootstrap/
+  [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
 
   # make sure we have our files for later use via chroot-script
   cp $VERBOSE $CONFFILES/config    $MNTPOINT/etc/debootstrap/
@@ -746,14 +830,29 @@ preparechroot() {
   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
   sed -i "s#GROOT=.*#GROOT=\"$GROOT\"#"       $MNTPOINT/etc/debootstrap/config
 
+  # install notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" $MNTPOINT/etc/debootstrap/
+  fi
+
+  # package selection:
   cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
     $MNTPOINT/etc/debootstrap/packages
+
+  # debconf preseeding:
   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
   [ -f $_opt_debconf -a "$DEBCONF" = 'yes' ] && \
     cp $VERBOSE $_opt_debconf $MNTPOINT/etc/debootstrap/debconf-selections
 
+  # copy scripts that should be executed inside the chroot:
+  _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
+  [ -d $_opt_chroot_scripts -a "$CHROOT_SCRIPTS" = 'yes' ] && {
+    mkdir -p $MNTPOINT/etc/debootstrap/chroot-scripts
+    cp -a $VERBOSE $_opt_chroot_scripts/* $MNTPOINT/etc/debootstrap/chroot-scripts/
+  }
+
   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
-  cp $VERBOSE $CHROOT_VARIABLES          $MNTPOINT/etc/debootstrap/variables
+  cp $VERBOSE $CHROOT_VARIABLES  $MNTPOINT/etc/debootstrap/variables
 
   cp $VERBOSE -a -L $CONFFILES/extrapackages/ $MNTPOINT/etc/debootstrap/
 
@@ -763,7 +862,6 @@ preparechroot() {
   # provide system's /etc/hosts to the target:
   if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
      cp $VERBOSE /etc/hosts $MNTPOINT/etc/hosts
-     sed -i "s#127.0.0.1 .*#127.0.0.1       localhost  $HOSTNAME#" /etc/hosts
   fi
 
   # setup default locales
@@ -791,6 +889,22 @@ preparechroot() {
 }
 # }}}
 
+# execute all scripts in /etc/debootstrap/scripts/ {{{
+execute_scripts() {
+   # make sure we have $MNTPOINT available for our scripts
+   export MNTPOINT
+   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
+      [ -d "$_opt_scripts" ] && scripts="$_opt_scripts" || scripts="$CONFFILES/scripts/"
+      for script in ${scripts}/* ; do
+         if [ -x "$script" ] ; then
+            einfo "Executing script $script"
+            $script ; eend $?
+         fi
+      done
+   fi
+}
+# }}}
+
 # execute chroot-script {{{
 chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
@@ -832,8 +946,14 @@ grub_install() {
 }
 # }}}
 
-# unmount $MNTPOINRT {{{
+# unmount $MNTPOINT {{{
 umount_chroot() {
+
+  # display installation notes:
+  if [ -n "$INSTALL_NOTES" ] ; then
+     [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
+  fi
+
   if [ -n "$ISODIR" ] ; then
      if grep -q "$ISODIR" /proc/mounts ; then
         einfo "Unmount $MNTPOINT/$ISODIR"
@@ -841,6 +961,7 @@ umount_chroot() {
         eend $?
      fi
   fi
+
   if grep -q "$MNTPOINT" /proc/mounts ; then
      if [ -n "$PARTITION" ] ; then
         einfo "Unmount $MNTPOINT"
@@ -864,7 +985,8 @@ fscktool() {
 
 # now execute all the functions {{{
 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
-         chrootscript grub_install umount_chroot fscktool ; do
+         chrootscript execute_scripts grub_install umount_chroot   \
+         fscktool ; do
     if stage "${i}" ; then
        $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
     fi